﻿//-----------------------------------------------------------------------
// <copyright file="ListViewGroupSorter.cs" company="MSCRMTools">
//     Copyright © MSCRMTools. All rights reserved.
// </copyright>
// <authorSTE_ALSY\tanguy.touzard</author>
// <date>23/09/2011</date>
// <codeplexurl>http://roleupdater.codeplex.com</codeplexurl>
// <summary>no summary</summary>
//-----------------------------------------------------------------------
using System.Collections.Generic;
using System.Windows.Forms;

namespace RoleUpdater
{
    public class ListViewGroupSorter
    {
        internal ListView _listview;

        public static bool operator ==(ListView listview, ListViewGroupSorter sorter)
        {
            return listview == sorter._listview;
        }
        public static bool operator !=(ListView listview, ListViewGroupSorter sorter)
        {
            return listview != sorter._listview;
        }

        public static implicit operator ListView(ListViewGroupSorter sorter)
        {
            return sorter._listview;
        }
        public static implicit operator ListViewGroupSorter(ListView listview)
        {
            return new ListViewGroupSorter(listview);
        }

        internal ListViewGroupSorter(ListView listview)
        {
            _listview = listview;
        }

        public void SortGroups(bool ascending)
        {
            _listview.BeginUpdate();
            List<ListViewGroup> lvgs = new List<ListViewGroup>();
            foreach (ListViewGroup lvg in _listview.Groups)
                lvgs.Add(lvg);
            _listview.Groups.Clear();
            lvgs.Sort(new ListViewGroupHeaderSorter(ascending));
            _listview.Groups.AddRange(lvgs.ToArray());
            _listview.EndUpdate();
        }

        #region overridden methods

        public override bool Equals(object obj)
        {
            return _listview.Equals(obj);
        }

        public override int GetHashCode()
        {
            return _listview.GetHashCode();
        }

        public override string ToString()
        {
            return _listview.ToString();
        }

        #endregion
    }
}